--------------------------------------------------------------------------------------------------------
--                                             AceAddon init                                          --
--------------------------------------------------------------------------------------------------------
Broker_BagInfo = LibStub("AceAddon-3.0"):NewAddon("Broker_BagInfo", "AceEvent-3.0")
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local Crayon = LibStub:GetLibrary("LibCrayon-3.0")


--------------------------------------------------------------------------------------------------------
--                                        Broker_BagInfo core                                         --
--------------------------------------------------------------------------------------------------------
function Broker_BagInfo:OnInitialize()	
	self:RegisterEvent("BAG_UPDATE","MainUpdate")
	self:RegisterEvent("UNIT_INVENTORY_CHANGED","MainUpdate")
	
	self:MainUpdate()
end

-- LDB object
Broker_BagInfo.obj = ldb:NewDataObject("Broker_BagInfo", {
	type = "data source",
	label = "Broker_BagInfo",
	text = "0/0",
	icon = "Interface\\Icons\\INV_Misc_Bag_10",
	OnTooltipShow = function(tooltip)
		if not tooltip or not tooltip.AddLine then return end
		tooltip:AddLine("Broker_BagInfo "..GetAddOnMetadata("Broker_BagInfo", "Version"))
	end,
})


--------------------------------------------------------------------------------------------------------
--                                      Broker_BagInfo functions                                      --
--------------------------------------------------------------------------------------------------------
-- Main update function
function Broker_BagInfo:MainUpdate()
	local total, free = 0, 0
	
	for i = 0, NUM_BAG_SLOTS do
		if i >= 0 then
			local _, bagType = GetContainerNumFreeSlots(i)
			if bagType then
				if not (self:IsAmmoBag(bagType) or self:IsProfessionBag(bagType)) then
					total = total + GetContainerNumSlots(i)
					free = free + GetContainerNumFreeSlots(i)
				end
			end
		end
	end
	
	local taken = total - free
	self.obj.text = (string.format("|cff%s%d/%d|r", Crayon:GetThresholdHexColor(free / total), taken, total))
end

function Broker_BagInfo:IsAmmoBag(bagType)
	-- 4: Soul Bag
	-- 2: Ammo Pouch
	-- 1: Quiver
	if bagType == 4 or bagType == 2 or bagType == 1 then
		return true
	end
	return false
end

function Broker_BagInfo:IsProfessionBag(bagType)
	-- 1024: Mining Bag
	-- 512: Gem Bag
	-- 128: Engineering Bag
	-- 64: Enchanting Bag
	-- 32: Herb Bag
	-- 16: Inscription Bag
	-- 8: Leatherworking Bag
	if bagType == 1024 or bagType == 512 or bagType == 128 or bagType == 64 or bagType == 32 or bagType == 16 or bagType == 8 then
		return true
	end
	return false
end
